#ifndef _CANVAS_
#define _CANVAS_

/* Revision: 17 1.3.2.2 source/ui/widgets/canvas.h, cuawidgets, ioc.v400, 981126  */
/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1997, 1997                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _Canvas_h
#define _Canvas_h

/***********************************************************************
 * Canvas Widget Public Header File
 **********************************************************************/

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

/***********************************************************************
  ICLCanvas Widget Manager

  This widget is a subclass of Bulletin Board. The only "additional" feature
  over of Bulletin board is that requests are not refused.


 ***********************************************************************/

/* Class record constants */

externalref WidgetClass xiclCanvasWidgetClass;

typedef struct _XiclCanvasClassRec *XiclCanvasWidgetClass;
typedef struct _XiclCanvasRec      *XiclCanvasWidget;

#ifndef XiclIsCanvas
#define XiclIsCanvas(w)  (XtIsSubclass (w, xiclCanvasWidgetClass))
#endif



/********    Public Function Declarations    ********/
#ifdef _NO_PROTO

extern Widget XiclCreateCanvas() ;
#else

extern Widget XiclCreateCanvas( 
                        Widget p,
                        String name,
                        ArgList args,
                        Cardinal n) ;
#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _Canvas_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
#endif // CANVAS header guard
