// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 29 1.4.1.3 source/core/collect/iaes.inl, collection, ioc.v400, trackPseudoLevel  
#ifndef _IAES_INL_
#define _IAES_INL_

// ---
// IAEqualitySequence
// ---

#include <ilanglvl.hpp>


template <class Element>
inline
IAEqualitySequence <Element>::
IAEqualitySequence (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}


template <class Element>
inline
IAEqualitySequence <Element>::
~IAEqualitySequence ()
{
}

template <class Element>
inline long
IAEqualitySequence <Element>::
compare (IAEqualitySequence <Element> const& collection,
         long (*compFunc) (Element const&, Element const&)) const
{ return this->ImplOf (*this).
    Compare (this->ImplOf (collection), (ICompFunc)compFunc, 0);
}

template <class Element>
inline IBool
IAEqualitySequence <Element>::
locateFirst (Element const& element, ICursor& cursor) const
{ return this->ImplOf (*this).LocateFirst (&element, this->CrsrImplOf (cursor));
}

template <class Element>
inline IBool
IAEqualitySequence <Element>::
locateLast (Element const& element, ICursor& cursor) const
{ return this->ImplOf (*this).LocateLast (&element, this->CrsrImplOf (cursor));
}

template <class Element>
inline IBool
IAEqualitySequence <Element>::
locatePrevious (Element const& element, ICursor& cursor) const
{ return this->ImplOf (*this).LocatePrevious (&element, this->CrsrImplOf (cursor));
}

template <class Element>
inline IBool
IAEqualitySequence <Element>::
operator== (IAEqualitySequence <Element> const& collection) const
{ return this->ImplOf (*this).operator== (this->ImplOf (collection));
}

template <class Element>
inline IBool
IAEqualitySequence <Element>::
operator!= (IAEqualitySequence <Element> const& collection) const
{ return this->ImplOf (*this).operator!= (this->ImplOf (collection));
}

// protected members

template <class Element>
inline
IAEqualitySequence <Element>::
IAEqualitySequence ()
{
}

template <class Element>
inline
IAEqualitySequence <Element>::
IAEqualitySequence (IAEqualitySequence <Element> const& collection)
: Inherited (collection)
{
}

// private members

template <class Element>
inline TYPENAME IAEqualitySequence <Element>::Implementation&
IAEqualitySequence <Element>::
ImplOf (IAEqualitySequence <Element> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IAES_INL_
