// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 35 1.4.1.4 source/core/collect/iakey.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IAKEY_
#define _IAKEY_

#include <iacllct.h>













#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class Key>
class IAKeyCollection : public virtual IACollection <Element> 
{
  typedef  IACollectionImpl Implementation;

public:


           IAKeyCollection  (INotifier&);


          ~IAKeyCollection  ();




  IBool addOrReplaceElementWithKey
                            (Element const&);




  IBool addOrReplaceElementWithKey
                            (Element const&, ICursor&);

  IBool containsAllKeysFrom
                            (IACollection <Element> const&) const; 

  IBool containsElementWithKey
                            (Key const&) const;

  Element& elementWithKey   (Key const&);

  Element const&
           elementWithKey   (Key const&) const;

  Key const&
           key              (Element const&) const;

  IBool locateElementWithKey
                            (Key const&, ICursor&) const;

  IBool locateNextElementWithKey
                            (Key const&, ICursor&) const;




  IBool locateOrAddElementWithKey
                            (Element const&);




  IBool locateOrAddElementWithKey
                            (Element const&, ICursor&);

  INumber  numberOfDifferentKeys
                            () const;

  INumber  numberOfElementsWithKey
                            (Key const&) const;




  INumber  removeAllElementsWithKey
                            (Key const&);




  IBool removeElementWithKey
                            (Key const&);




  IBool replaceElementWithKey
                            (Element const&);




  IBool replaceElementWithKey
                            (Element const&, ICursor&);

  IBool setToNextWithDifferentKey
                            (ICursor&) const;

protected:

           IAKeyCollection  ();

           IAKeyCollection  (IAKeyCollection <Element, Key> const&);

private:

  static
  Implementation&
           ImplOf           (IAKeyCollection <Element, Key> const&);










































};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif





#include <iakey.inl>





#endif // _IAKEY_
