// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 53 1.4.1.4 source/core/collect/iaorder.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IAORDER_
#define _IAORDER_

#include <iacllct.h>













#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element>
class IOrderedCursor : public IElementCursor <Element> 
{
  typedef  ICursorImpl Implementation;

public:

  IBool setToLast        ();

  IBool setToPrevious    ();

protected:

           IOrderedCursor   (Implementation*);











};

template <class Element>
class IAOrderedCollection : public virtual IACollection <Element> {

  typedef  IACollectionImpl Implementation;

public:


           IAOrderedCollection
                            (INotifier&);


          ~IAOrderedCollection
                            ();

  Element const&
           elementAtPosition
                            (IPosition) const;

  Element const&
           first            () const;

  IBool isFirstAt        (ICursor const&) const;

  IBool isLastAt         (ICursor const&) const;

  Element const&
           last             () const;

  IPosition
           positionAt       (ICursor const&) const;




  void     removeAtPosition (IPosition);




  void     removeFirst      ();




  void     removeLast       ();

  IBool setToLast        (ICursor&) const;

  void     setToPosition    (IPosition, ICursor&) const;

  IBool setToPrevious    (ICursor&) const;

  // for backward compatibility
  Element const&
           firstElement     () const;

  IBool isFirst          (ICursor const&) const;

  IBool isLast           (ICursor const&) const;

  Element const&
           lastElement      () const;

  IPosition
           position         (ICursor const&) const;

protected:

           IAOrderedCollection
                            ();

           IAOrderedCollection
                            (IAOrderedCollection <Element> const&);

private:

  static
  Implementation&
           ImplOf           (IAOrderedCollection <Element> const&);





















};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif





#include <iaorder.inl>





#endif // _IAORDER_
