// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 55 1.4.1.4 source/core/collect/iappl.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IAPPL_
#define _IAPPL_

#include <iglobals.h>













#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element>
class IApplicator
{
public:

  virtual
  IBool applyTo          (Element&) = 0;

protected:

private:









};

template <class Element>
class IConstantApplicator 
{
public:

  virtual
  IBool applyTo          (Element const&) = 0;

protected:

private:









};

class IInternalApplicator 
{
public:

  virtual
  IBool applyTo          (void*)
           { return true;
           }

protected:

private:









};

#pragma enum(pop)
#pragma pack(pop)

inline IBool
__applFunc (void* element, void* applicator)
{



  return ((IInternalApplicator*)applicator)->applyTo (element);
}

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif









#endif // _IAPPL_
