// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 63 1.4.1.3 source/core/collect/iarel.inl, collection, ioc.v400, trackPseudoLevel  
#ifndef _IAREL_INL_
#define _IAREL_INL_

// ---
// IARelation
// ---

#include <ilanglvl.hpp>


template <class Element, class Key>
inline
IARelation <Element, Key>::
IARelation (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}


template <class Element, class Key>
inline
IARelation <Element, Key>::
~IARelation ()
{
}

template <class Element, class Key>
inline void
IARelation <Element, Key>::
addDifference (IARelation <Element, Key> const& collection1,
               IARelation <Element, Key> const& collection2)
{ this->ImplOf (*this).
    AddDifference (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element, class Key>
inline void
IARelation <Element, Key>::
addIntersection (IARelation <Element, Key> const& collection1,
                 IARelation <Element, Key> const& collection2)
{ this->ImplOf (*this).
    AddIntersection (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element, class Key>
inline void
IARelation <Element, Key>::
addUnion (IARelation <Element, Key> const& collection1,
          IARelation <Element, Key> const& collection2)
{ this->ImplOf (*this).
    AddUnion (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element, class Key>
inline void
IARelation <Element, Key>::
differenceWith (IARelation <Element, Key> const& collection)
{ this->ImplOf (*this).Difference (this->ImplOf (collection));
}

template <class Element, class Key>
inline void
IARelation <Element, Key>::
intersectionWith (IARelation <Element, Key> const& collection)
{ this->ImplOf (*this).Intersection (this->ImplOf (collection));
}

template <class Element, class Key>
inline void
IARelation <Element, Key>::
unionWith (IARelation <Element, Key> const& collection)
{ this->ImplOf (*this).Union (this->ImplOf (collection));
}

template <class Element, class Key>
inline IBool
IARelation <Element, Key>::
operator== (IARelation <Element, Key> const& collection) const
{ return this->ImplOf (*this).operator== (this->ImplOf (collection));
}

template <class Element, class Key>
inline IBool
IARelation <Element, Key>::
operator!= (IARelation <Element, Key> const& collection) const
{ return this->ImplOf (*this).operator!= (this->ImplOf (collection));
}

// protected members

template <class Element, class Key>
inline
IARelation <Element, Key>::
IARelation ()
{
}

template <class Element, class Key>
inline
IARelation <Element, Key>::
IARelation (IARelation <Element, Key> const& collection)
: Inherited (collection)
{
}

template <class Element, class Key>
inline IBool
IARelation <Element, Key>::
locateNext (Element const& element, ICursor& cursor) const
{ return IAEqualityCollection <Element>::locateNext (element, cursor);
}

template <class Element, class Key>
inline INumber
IARelation <Element, Key>::
numberOfOccurrences (Element const& element) const
{ return IAEqualityCollection <Element>::numberOfOccurrences (element);
}

template <class Element, class Key>
inline INumber
IARelation <Element, Key>::
removeAllOccurrences (Element const& element)
{ return IAEqualityCollection <Element>::removeAllOccurrences (element);
}

// private members

template <class Element, class Key>
inline TYPENAME IARelation <Element, Key>::Implementation&
IARelation <Element, Key>::
ImplOf (IARelation <Element, Key> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IAREL_INL_
