// Revision: 60 1.5.1.3 source/ui/baseapp/iarglist.hpp, basewin, ioc.v400, 981126  
#ifndef _IARGLIST_
#define _IARGLIST_
/*******************************************************************************
* FILE NAME: iarglist.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IArgList                                                                 *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>
#include <iuipl.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IArgListData;

#pragma enum(4)
#pragma pack(push,4)

class IArgList {
public:

IArgList( );
IArgList( const IArgList& argList );
~IArgList( );

IArgList
 &operator=( const IArgList& argList );

/*
  Styles are converted to resources for Motif. Resources are actually strings on
  Motif. setResource is used to set the resource arg,value pair that allows us to
  build the ArgList.

  XtArgVal is typedef to a long on every platform but cray.
*/                                     

IArgList
 &setResource( char* arg, long value );

/*
  ArgList is a pointer to the unnamed data structure args. We return the arglist
  as a void* to avoid including X header files.
*/
void
 *argList();
unsigned long
  numberOfArgs();

private:

IArgListData
 *pData;
};

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _IARGLIST_
