// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 86 1.4.1.3 source/core/collect/iass.inl, collection, ioc.v400, trackPseudoLevel  
#ifndef _IASS_INL_
#define _IASS_INL_

// ---
// IASortedSet
// ---

#include <ilanglvl.hpp>


template <class Element>
inline
IASortedSet <Element>::
IASortedSet (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}


template <class Element>
inline
IASortedSet <Element>::
~IASortedSet ()
{
}

template <class Element>
inline void
IASortedSet <Element>::
addDifference (IASortedSet <Element> const& collection1,
               IASortedSet <Element> const& collection2)
{ this->ImplOf (*this).
    AddDifference (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element>
inline void
IASortedSet <Element>::
addIntersection (IASortedSet <Element> const& collection1,
                 IASortedSet <Element> const& collection2)
{ this->ImplOf (*this).
    AddIntersection (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element>
inline void
IASortedSet <Element>::
addUnion (IASortedSet <Element> const& collection1,
          IASortedSet <Element> const& collection2)
{ this->ImplOf (*this).
    AddUnion (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element>
inline long
IASortedSet <Element>::
compare (IASortedSet <Element> const& collection,
         long (*compFunc) (Element const&, Element const&)) const
{ return this->ImplOf (*this).
    Compare (this->ImplOf (collection), (ICompFunc)compFunc, 0);
}

template <class Element>
inline void
IASortedSet <Element>::
differenceWith (IASortedSet <Element> const& collection)
{ this->ImplOf (*this).Difference (this->ImplOf (collection));
}

template <class Element>
inline void
IASortedSet <Element>::
intersectionWith (IASortedSet <Element> const& collection)
{ this->ImplOf (*this).Intersection (this->ImplOf (collection));
}

template <class Element>
inline void
IASortedSet <Element>::
unionWith (IASortedSet <Element> const& collection)
{ this->ImplOf (*this).Union (this->ImplOf (collection));
}

template <class Element>
inline IBool
IASortedSet <Element>::
operator== (IASortedSet <Element> const& collection) const
{ return this->ImplOf (*this).operator== (this->ImplOf (collection));
}

template <class Element>
inline IBool
IASortedSet <Element>::
operator!= (IASortedSet <Element> const& collection) const
{ return this->ImplOf (*this).operator!= (this->ImplOf (collection));
}

// protected members

template <class Element>
inline
IASortedSet <Element>::
IASortedSet ()
{
}

template <class Element>
inline
IASortedSet <Element>::
IASortedSet (IASortedSet <Element> const& collection)
: Inherited (collection)
{
}

template <class Element>
inline INumber
IASortedSet <Element>::
numberOfOccurrences (Element const& element) const
{ return IAEqualityCollection <Element>::numberOfOccurrences (element);
}

template <class Element>
inline INumber
IASortedSet <Element>::
removeAllOccurrences (Element const& element)
{ return IAEqualityCollection <Element>::removeAllOccurrences (element);
}

// private members

template <class Element>
inline TYPENAME IASortedSet <Element>::Implementation&
IASortedSet <Element>::
ImplOf (IASortedSet <Element> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IASS_INL_
