// Revision: 84 1.8.1.2 source/ui/baseapp/ibitflag.inl, datatype, ioc.v400, 981126 
#ifndef _IBITFLAG_INL_
#define _IBITFLAG_INL_
/*******************************************************************************
* FILE NAME: ibitflag.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in ibitflag.hpp.                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   Licensed Material - Property of IBM                                        *
*   (C) Copyright IBM Corp. 1992, 1997  All Rights Reserved                    *
*                                                                              *
*******************************************************************************/

#if ( IC_OBSOLETE <= IC_OBSOLETE_3 )
inline IBitFlag::IBitFlag ( unsigned long value,
                            unsigned long extValue )
{
  fBitValue[ 0 ] = value;
  fBitValue[ 1 ] = extValue;
  fBitValue[ 2 ] = 0;
}

inline IBitFlag::IBitFlag ( unsigned long value )
{
  fBitValue[ 0 ] = value;
  fBitValue[ 1 ] = 0;
  fBitValue[ 2 ] = 0;
}

inline unsigned long IBitFlag::asUnsignedLong ( ) const
{
  return this->fBitValue[ 0 ];
}

inline unsigned long IBitFlag::asExtendedUnsignedLong ( ) const
{
  return this->fBitValue[ 1 ];
}

inline IBitFlag& IBitFlag::setValue ( unsigned long value,
                                      unsigned long extValue )
{
  this->fBitValue[ 0 ] = value;
  this->fBitValue[ 1 ] = extValue;
  this->fBitValue[ 2 ] = 0;
  return *this;
}
#endif // IC_OBSOLETE

#endif // _IBITFLAG_INL_
