// Revision: 80 1.8.1.3 source/ui/cnr/icnrctl.inl, container, ioc.v400, trackPseudoLevel 
#ifndef _ICNRCTL_INL_
#define _ICNRCTL_INL_
/*******************************************************************************
* FILE NAME: icnrctl.inl                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in icnrctl.hpp.                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   Licensed Material - Property of IBM                                        *
*   (C) Copyright IBM Corp. 1992, 1997  All Rights Reserved.                   *
*                                                                              *
*******************************************************************************/
#include <itrace.hpp>

inline IBool IContainerControl::operator==( const IContainerControl& that)
       { return (&that==this); }

inline IBool IContainerControl::willDeleteObjectsOnClose( ) const
       { return ((flClState & IContainerControl::autoDeleteObjects) ? true : false);}

inline IBool IContainerControl::willDeleteColumnsOnClose( ) const
       { return ((flClState & IContainerControl::autoDeleteColumns) ? true : false);}

inline unsigned long IContainerControl::numberOfObjectChanges() const
       {return ulClObjectChanges; }

inline unsigned long IContainerControl::numberOfColumnChanges() const
       {return ulClColumnChanges; }

#ifndef IC_MOTIF
inline IBool IContainerControl::isRefreshOn() const
{ return ((flClState & IContainerControl::noRefresh) ? false : true); }
#endif

#ifndef IC_MOTIF_FLAGNOP
inline IContainerControl& IContainerControl :: disableCaching()
{
ITRACE_MOTIF_NOP();
#ifdef IC_PMWIN
   enableCaching(0);
   return *this;
#endif
#ifdef IC_MOTIF
  return *this;
#endif
}
#endif
#endif // _ICNRCTL_INL_
