// Revision: 17 1.8.1.3 source/ui/cnr/icnrobj.inl, container, ioc.v400, trackPseudoLevel  
#ifndef _ICNROBJ_INL_
#define _ICNROBJ_INL_
/*******************************************************************************
* FILE NAME: icnrobj.inl                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in icnrobj.hpp.                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*                                                                              *
*******************************************************************************/

#include <itrace.hpp>

inline unsigned long IContainerObject::useCount ( ) const
{
  return ((IContainerObject*)this)->ulClUseCount;
}

inline IMiniCnrRecord* IContainerObject::baseRecord ( )
{
  return ((IContainerObject*)this)->pbase;
}

#ifndef IC_MOTIF
inline void IContainerObject::setDelayedFree ( IBool delay )
{
  delayFree = delay;
}

inline IBool IContainerObject::isDelayedFree ( ) const
{
  return delayFree;
}
#endif

inline void* ICnrAllocator::first ( ) const
{
  return pFirst;
}

inline unsigned long ICnrAllocator::initialized ( ) const
{
  return numInitialized;
}
#endif // _ICNROBJ_INL_
