/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 11 1.5.1.4 source/albert/graph2d/igcurv2d.inl, 2d, ioc.v400, 981126 
/*==========================================
||
||  File:   CurveImp.h
||
||  What:   Albert 2D Curve Geometry inline definitions
||
*/

#ifndef _IGCURV2D_INL_
#define _IGCURV2D_INL_

// Inlines to export base class overloading

inline
IGPoint2D IGCurve2D::evaluate(GParametric u) const {
        return IBaseCurve<IGRPoint2D,IGPoint2D>::evaluate(u);
}

inline
IGRPoint2D IGCurve2D::evaluateW(GParametric u) const {
        return IBaseCurve<IGRPoint2D,IGPoint2D>::evaluateW(u);
}

inline
IGPoint2D IGCurve2D::evaluate(GParametric u, IGPoint2D& tangent) const {
        return IBaseCurve<IGRPoint2D, IGPoint2D>::evaluate(u, tangent);
}

inline
IGPoint2D IGCurve2D::evaluate(
        GParametric u,
    IGPoint2D& tangent,
    IGPoint2D& deriv2) const {
        return IBaseCurve<IGRPoint2D, IGPoint2D>::evaluate(u, tangent, deriv2);
}

inline
void IGCurve2D::makeCompatible(IGCurve2D& curve1, IGCurve2D& curve2) {
        IBaseCurve<IGRPoint2D, IGPoint2D>::makeCompatible(curve1, curve2);
}

#endif // _IGCURV2D_INL_
