// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 04 1.4.1.2 source/core/collect/iibaghsh.c, collection, ioc.v400, 981126 
#ifndef _IIBAGHSH_C_
#define _IIBAGHSH_C_





// ---
// IBagAsHshTableOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
IBagAsHshTableOps <Element, ElementOps, Implementation>::
IBagAsHshTableOps (INumber numberOfElements)
: Inherited (__isDTSClass (Element)),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IBagAsHshTableOps <Element, ElementOps, Implementation>::
IBagAsHshTableOps (INumber numberOfElements, void* opsArg)
: Inherited (__isDTSClass (Element)),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IBagAsHshTableOps <Element, ElementOps, Implementation>::
IBagAsHshTableOps
  (IBagAsHshTableOps
    <Element, ElementOps, Implementation> const& collection)
: Inherited (__isDTSClass (Element)),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
IBagAsHshTableOps <Element, ElementOps, Implementation>::
~IBagAsHshTableOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
IBagAsHshTableOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
IBagAsHshTableOps <Element, ElementOps, Implementation>::
operator IKeyBagAsHshTableImpl& ()
{ return *(IKeyBagAsHshTableImpl*)ivBase;
}

template <class Element, class ElementOps, class Implementation>
IBagAsHshTableOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}





#endif // _IIBAGHSH_C_
