// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 21 1.6.1.5 source/core/collect/iichp.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IICHP_
#define _IICHP_

#include <ilanglvl.hpp>
#include <iiahp.h>













#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class CInherited>
class ICHeapImpl : public CInherited {
public:

  typedef TYPENAME CInherited::Ops Ops;

           ICHeapImpl
                            (Ops&, INumber);

           ICHeapImpl
                            (Ops&, ICHeapImpl
                                    <CInherited> const&);

  IBool     Add              (void const*, ICursorImpl&);

  void     AddAllFrom       (IACollectionImpl const&);

  void*    Any              () const;

  void*    ElementAt        (ICursorImpl const&) const;

  void     RemoveAt         (ICursorImpl&);

  void     ReplaceAt        (ICursorImpl const& cursor,
                             void const*);

  IBool     SetToFirst       (ICursorImpl&) const;

  IBool     SetToNext        (ICursorImpl&) const;

protected:

private:












};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif








#if ! defined (__TEMPINC__)
#include <iichp.c>
#endif






#endif // _IICHP_
