// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 25 1.6.1.5 source/core/collect/iicks.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IICKS_
#define _IICKS_

#include <ilanglvl.hpp>
#include <iiaks.h>













#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class CInherited>
class ICKeySetImpl : public CInherited {
public:

  typedef TYPENAME CInherited::Ops Ops;

           ICKeySetImpl
                            (Ops&, INumber);

           ICKeySetImpl
                            (Ops&, ICKeySetImpl
                                    <CInherited> const&);

  IBool     Add              (void const*, ICursorImpl&);

  void     AddAllFrom       (IACollectionImpl const&);

  IBool     AddOrReplaceElementWithKey
                            (void const*, ICursorImpl&);

  void*    Any              () const;

  void*    ElementAt        (ICursorImpl const&) const;

  void*    ElementWithKey   (void const*) const;

  IBool     LocateElementWithKey
                            (void const*, ICursorImpl&) const;

  IBool     LocateNextElementWithKey
                            (void const*, ICursorImpl&) const;

  IBool     LocateOrAddElementWithKey
                            (void const*, ICursorImpl&);

  void     RemoveAt         (ICursorImpl&);

  void     ReplaceAt        (ICursorImpl const& cursor,
                             void const*);

  IBool     ReplaceElementWithKey
                            (void const*, ICursorImpl&);

  IBool     SetToFirst       (ICursorImpl&) const;

  IBool     SetToNext        (ICursorImpl&) const;

  IBool     SetToNextWithDifferentKey
                            (ICursorImpl&) const;

protected:

private:












};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif








#if ! defined (__TEMPINC__)
#include <iicks.c>
#endif






#endif // _IICKS_
