// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 27 1.6.1.5 source/core/collect/iicksb.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IICKSB_
#define _IICKSB_

#include <ilanglvl.hpp>
#include <iiaksb.h>













#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class CInherited>
class ICKeySortedBagImpl : public CInherited {
public:

  typedef TYPENAME CInherited::Ops Ops;

           ICKeySortedBagImpl
                            (Ops&, INumber);

           ICKeySortedBagImpl
                            (Ops&, ICKeySortedBagImpl
                                    <CInherited> const&);

  IBool     Add              (void const*, ICursorImpl&);

  void     AddAllFrom       (IACollectionImpl const&);

  IBool     AddOrReplaceElementWithKey
                            (void const*, ICursorImpl&);

  void*    Any              () const;

  void*    ElementAt        (ICursorImpl const&) const;

  void*    ElementAtPosition
                            (IPosition) const;

  void*    ElementWithKey   (void const*) const;

  void*    First            () const;

  IBool     IsFirstAt        (ICursorImpl const&) const;

  IBool     IsLastAt         (ICursorImpl const&) const;

  void*    Last             () const;

  IBool     LocateElementWithKey
                            (void const*, ICursorImpl&) const;

  IBool     LocateNextElementWithKey
                            (void const*, ICursorImpl&) const;

  IBool     LocateOrAddElementWithKey
                            (void const*, ICursorImpl&);

  IPosition
           PositionAt       (ICursorImpl const&) const;

  void     RemoveAt         (ICursorImpl&);

  void     RemoveAtPosition (IPosition);

  void     RemoveFirst      ();

  void     RemoveLast       ();

  void     ReplaceAt        (ICursorImpl const& cursor,
                             void const*);

  void     ReplaceAtPosition
                            (IPosition, void const*);

  IBool     ReplaceElementWithKey
                            (void const*, ICursorImpl&);

  IBool     SetToFirst       (ICursorImpl&) const;

  IBool     SetToLast        (ICursorImpl&) const;

  IBool     SetToNext        (ICursorImpl&) const;

  IBool     SetToNextWithDifferentKey
                            (ICursorImpl&) const;

  void     SetToPosition    (IPosition, ICursorImpl&) const;

  IBool     SetToPrevious    (ICursorImpl&) const;

protected:

private:












};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif








#if ! defined (__TEMPINC__)
#include <iicksb.c>
#endif






#endif // _IICKSB_
