// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 47 1.6.1.5 source/core/collect/iicss.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IICSS_
#define _IICSS_

#include <ilanglvl.hpp>
#include <iiass.h>













#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class CInherited>
class ICSortedSetImpl : public CInherited {
public:

  typedef TYPENAME CInherited::Ops Ops;

           ICSortedSetImpl
                            (Ops&, INumber);

           ICSortedSetImpl
                            (Ops&, ICSortedSetImpl
                                    <CInherited> const&);

  IBool     Add              (void const*, ICursorImpl&);

  void     AddAllFrom       (IACollectionImpl const&);

  void*    Any              () const;

  void*    ElementAt        (ICursorImpl const&) const;

  void*    ElementAtPosition
                            (IPosition) const;

  void*    First            () const;

  IBool     IsFirstAt        (ICursorImpl const&) const;

  IBool     IsLastAt         (ICursorImpl const&) const;

  void*    Last             () const;

  IBool     Locate           (void const*, ICursorImpl&) const;

  IBool     LocateNext       (void const*, ICursorImpl&) const;

  IBool     LocateOrAdd      (void const*, ICursorImpl&);

  IPosition
           PositionAt       (ICursorImpl const&) const;

  void     RemoveAt         (ICursorImpl&);

  void     RemoveAtPosition (IPosition);

  void     RemoveFirst      ();

  void     RemoveLast       ();

  void     ReplaceAt        (ICursorImpl const& cursor,
                             void const*);

  void     ReplaceAtPosition
                            (IPosition, void const*);

  IBool     SetToFirst       (ICursorImpl&) const;

  IBool     SetToLast        (ICursorImpl&) const;

  IBool     SetToNext        (ICursorImpl&) const;

  void     SetToPosition    (IPosition, ICursorImpl&) const;

  IBool     SetToPrevious    (ICursorImpl&) const;

protected:

private:












};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif








#if ! defined (__TEMPINC__)
#include <iicss.c>
#endif






#endif // _IICSS_
