// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 66 1.4.1.2 source/core/collect/iihplst.c, collection, ioc.v400, 981126 
#ifndef _IIHPLST_C_
#define _IIHPLST_C_





// ---
// IHeapAsListOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
IHeapAsListOps <Element, ElementOps, Implementation>::
IHeapAsListOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IHeapAsListOps <Element, ElementOps, Implementation>::
IHeapAsListOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IHeapAsListOps <Element, ElementOps, Implementation>::
IHeapAsListOps
  (IHeapAsListOps
    <Element, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
IHeapAsListOps <Element, ElementOps, Implementation>::
~IHeapAsListOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
IHeapAsListOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
IHeapAsListOps <Element, ElementOps, Implementation>::
operator ISequenceAsListImpl& ()
{ return *(ISequenceAsListImpl*)ivBase;
}

template <class Element, class ElementOps, class Implementation>
IHeapAsListOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}





#endif // _IIHPLST_C_
