// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 85 1.4.1.2 source/core/collect/iikblst.c, collection, ioc.v400, 981126 
#ifndef _IIKBLST_C_
#define _IIKBLST_C_





// ---
// IKeyBagAsListOps
// ---

// public members

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsListOps <Element, Key, ElementOps, Implementation>::
IKeyBagAsListOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsListOps <Element, Key, ElementOps, Implementation>::
IKeyBagAsListOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsListOps <Element, Key, ElementOps, Implementation>::
IKeyBagAsListOps
  (IKeyBagAsListOps
    <Element, Key, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsListOps <Element, Key, ElementOps, Implementation>::
~IKeyBagAsListOps ()
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IACollectionImpl*
IKeyBagAsListOps <Element, Key, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsListOps <Element, Key, ElementOps, Implementation>::
operator IKeySortedBagAsListImpl& ()
{ return *(IKeySortedBagAsListImpl*)ivBase ;
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeyBagAsListOps <Element, Key, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}





#endif // _IIKBLST_C_
