// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 18 1.6.1.4 source/core/collect/iikskb.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IIKSKB_
#define _IIKSKB_

#include <ilanglvl.hpp>
#include <iiaks.h>


















#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Base>
class IKeySetOnKeyBagMngCursorImpl;

template <class Base>
class IKeySetOnKeyBagImpl;

#pragma pack(push,4)
#pragma enum(4)

template <class Base>
class IC_EXPORTC IKeySetOnKeyBagMngCursorImpl : public Base::MngCursor 
{

  typedef TYPENAME Base::MngCursor Inherited;

public:

           IKeySetOnKeyBagMngCursorImpl
                            (IKeySetOnKeyBagImpl <Base> const&);

          ~IKeySetOnKeyBagMngCursorImpl
                            ();

protected:

private:









};

template <class Base>
class IBagOnKeySetImpl;

template <class Base>
class IAKeySetOnKeyBagOps;

template <class Base>
class IC_EXPORTC IKeySetOnKeyBagImpl : public IAKeySetImpl {

  typedef  IAKeySetImpl Inherited;

  typedef  IKeySetOnKeyBagImpl <Base> Self;

public:

  typedef  IAKeySetOnKeyBagOps <Base> Ops;

  typedef TYPENAME Base::Cursor Cursor;

  typedef  IKeySetOnKeyBagMngCursorImpl <Base> MngCursor;

           IKeySetOnKeyBagImpl
                            (Ops&, INumber);

           IKeySetOnKeyBagImpl
                            (Ops&, IKeySetOnKeyBagImpl <Base> const&);

          ~IKeySetOnKeyBagImpl
                            ();

  IBool Add              (void const*, ICursorImpl&);

  IBool AddOrReplaceElementWithKey
                            (void const*, ICursorImpl&);

  IBool AllElementsDo    (IApplFunc, void*);

  void*    Any              () const;

  IBool CheckCursor      (ICursorImpl const&) const;

  IBool CheckReplacement (ICursorImpl const&, void const* ) const;

  char const*
           ClassName        () const;

  IACollectionImpl*
           Clone            () const;

  IBool ContainsAllKeysFrom
                            (IACollectionImpl const&) const;

  IBool ContainsElementWithKey
                            (void const*) const;

  void     Copy             (IACollectionImpl const&);

  ICursorImpl*
           CreateCursor     () const;

  ICursorImpl*
           CreateMngCursor  () const;

  void*    ElementAt        (ICursorImpl const&) const;

  void*    ElementWithKey   (void const*) const;

  IBool IsBounded        () const;

  IBool IsConsistent     () const;

  IBool IsEmpty          () const;

  IBool IsFull           () const;

  void*    Key              (void const*) const;

  IBool LocateElementWithKey
                            (void const*, ICursorImpl&) const;

  IBool LocateOrAddElementWithKey
                            (void const*, ICursorImpl&);

  INumber  NumberOfElements () const;

  INumber  RemoveAll        ();

  INumber  RemoveAll        (IPredFunc, void*);

  void     RemoveAt         (ICursorImpl&);

  IBool RemoveElementWithKey
                            (void const*);

  void     ReplaceAt        (ICursorImpl const&, void const*);

  IBool ReplaceElementWithKey
                            (void const*, ICursorImpl&);

  IBool SetToFirst       (ICursorImpl&) const;

  IBool SetToNext        (ICursorImpl&) const;

  void     operator=        (IKeySetOnKeyBagImpl <Base> const&);

protected:

  IBool EqualKeys        (void const*, void const*, IArgType) const;

private:

  static
  char const*
           cvClassName;

  Base&    ivBase;

  static
  Base&    BaseOf           (IKeySetOnKeyBagImpl <Base> const&);

  static
  Ops&     OpsOf            (IKeySetOnKeyBagImpl <Base> const&);

  friend
  class    IKeySetOnKeyBagMngCursorImpl <Base>;

  friend
  class    IBagOnKeySetImpl <Self>;

#if ! defined (__INO_STREAMING__)
public:
  IStreamerPtr&
           StreamerOf       (IACollectionImpl const&);

  void     StreamIn         (IDataStream&);

  void     StreamOut        (IDataStream&) const;

  void     AdoptStreamer    (IACollectionStreamer*);
#endif





















};

template <class Base>
class IC_EXPORTC IAKeySetOnKeyBagOps {
public:

  virtual ~IAKeySetOnKeyBagOps
                            ();

  virtual
  IACollectionImpl*
           Clone            () const = 0;

  virtual  operator Base&   () = 0;

protected:

private:








};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif





#include <iikskb.inl>





#endif // _IIKSKB_
