// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 28 1.6.1.4 source/core/collect/iikssavl.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IIKSSAVL_
#define _IIKSSAVL_

#include <iiakss.h>














#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

typedef short Direction;

const short kAvlNone  =  0;

#pragma enum (4)
#pragma pack (push,4)

struct IAKeySortedSetAsAvlTreeNodeImpl {

  IAKeySortedSetAsAvlTreeNodeImpl
          *ivLeft,
          *ivRight,
          *ivParent;

  Direction
           ivDeeperSubtree;

           IAKeySortedSetAsAvlTreeNodeImpl
                            ();

  IAKeySortedSetAsAvlTreeNodeImpl*&
           Link             (Direction);

  void     Parent           (IAKeySortedSetAsAvlTreeNodeImpl*&,
                             Direction&);

  void     ConnectChild     (Direction,
                             IAKeySortedSetAsAvlTreeNodeImpl*);

  void     ConnectChild0    (Direction,
                             IAKeySortedSetAsAvlTreeNodeImpl*);

};

template <class Element>
struct IKeySortedSetAsAvlTreeNodeImpl :
  public IAKeySortedSetAsAvlTreeNodeImpl {

  Element  ivElement;

           IKeySortedSetAsAvlTreeNodeImpl
                            (Element const&);

          ~IKeySortedSetAsAvlTreeNodeImpl
                            ();

#if ! defined(__INO_STREAMING__)
  void     StreamIn         (IACollectionStreamer*, IDataStream&);
#endif







};










class IC_EXPORTC IKeySortedSetAsAvlTreeCursorImpl : public ICursorImpl {

  typedef  ICursorImpl Inherited;

  typedef  IKeySortedSetAsAvlTreeCursorImpl Self;

public:

           IKeySortedSetAsAvlTreeCursorImpl
                            (IACollectionImpl const&);

           IKeySortedSetAsAvlTreeCursorImpl
                            (IKeySortedSetAsAvlTreeCursorImpl const&);

          ~IKeySortedSetAsAvlTreeCursorImpl
                            ();

  ICursorImpl*
           Clone            () const;

  void     Copy             (ICursorImpl const&);

  void     Invalidate       ();

  IBool IsInBetween      () const;

  IBool IsValid          () const;

  void     operator=        (IKeySortedSetAsAvlTreeCursorImpl const&);

  IBool operator==       (ICursorImpl const&) const;

protected:

private:

  IAKeySortedSetAsAvlTreeNodeImpl*
           ivNode;

  friend
  class    IKeySortedSetAsAvlTreeImpl;










};






























































template <class Base>
class IKeySetOnKeySortedSetImpl;

template <class Base>
class ISortedBagOnKeySortedSetImpl;

template <class Base>
class ISortedMapOnKeySortedSetImpl;

class IAKeySortedSetAsAvlTreeOps;

class IC_EXPORTC IKeySortedSetAsAvlTreeImpl : public IAKeySortedSetImpl {

  typedef  IAKeySortedSetImpl Inherited;

  typedef  IKeySortedSetAsAvlTreeImpl Self;

  typedef  IAKeySortedSetAsAvlTreeNodeImpl Node;

#if ! defined (__INO_STREAMING__)
  typedef  IKeySortedSetAsAvlTreeNodeImpl<long> StreamerNode;
#endif

public:

  typedef  IAKeySortedSetAsAvlTreeOps Ops;

  typedef  IKeySortedSetAsAvlTreeCursorImpl Cursor;




  typedef  IKeySortedSetAsAvlTreeCursorImpl MngCursor;


           IKeySortedSetAsAvlTreeImpl
                            (Ops&, INumber);

           IKeySortedSetAsAvlTreeImpl
                            (Ops&, IKeySortedSetAsAvlTreeImpl const&);

          ~IKeySortedSetAsAvlTreeImpl
                            ();

  IBool Add              (void const*, ICursorImpl&);

  void     AddAllFrom       (IACollectionImpl const&);

  IBool AddOrReplaceElementWithKey
                            (void const*, ICursorImpl&);

  IBool AllElementsDo    (IApplFunc, void*);

  void*    Any              () const;

  IBool CheckCursor      (ICursorImpl const&) const;

  IBool CheckReplacement (ICursorImpl const&, void const*) const;

  char const*
           ClassName        () const;

  IACollectionImpl*
           Clone            () const;

  IBool ContainsAllKeysFrom
                            (IACollectionImpl const&) const;

  IBool ContainsElementWithKey
                            (void const*) const;

  void     Copy             (IACollectionImpl const&);

  Cursor*  CreateCursor     () const;

  MngCursor*
           CreateMngCursor  () const;

  void*    ElementAt        (ICursorImpl const&) const;

  void*    ElementAtPosition
                            (IPosition) const;

  void*    ElementWithKey   (void const*) const;

  void*    First            () const;

  IBool IsBounded        () const;

  IBool IsConsistent     () const;

  IBool IsEmpty          () const;

  IBool IsFirstAt        (ICursorImpl const&) const;

  IBool IsFull           () const;

  IBool IsLastAt         (ICursorImpl const&) const;

  void*    Key              (void const*) const;

  void*    Last             () const;

  IBool LocateElementWithKey
                            (void const*, ICursorImpl&) const;

  IBool LocateNextElementWithKey
                            (void const*, ICursorImpl&) const;

  IBool LocateOrAddElementWithKey
                            (void const*, ICursorImpl&);

  INumber  NumberOfElements () const;

  IPosition
           PositionAt       (ICursorImpl const&) const;

  INumber  RemoveAll        ();

  INumber  RemoveAll        (IPredFunc, void*);

  void     RemoveAt         (ICursorImpl&);

  void     RemoveAtPosition (IPosition);

  IBool RemoveElementWithKey
                            (void const*);

  void     RemoveFirst      ();

  void     RemoveLast       ();

  void     ReplaceAt        (ICursorImpl const&, void const*);

  void     ReplaceAtPosition
                            (IPosition, void const*);

  IBool ReplaceElementWithKey
                            (void const*, ICursorImpl&);

  IBool SetToFirst       (ICursorImpl&) const;

  IBool SetToNext        (ICursorImpl&) const;

  IBool SetToLast        (ICursorImpl&) const;

  void     SetToPosition    (IPosition, ICursorImpl&) const;

  IBool SetToPrevious    (ICursorImpl&) const;

  void     operator=        (IKeySortedSetAsAvlTreeImpl const&);

protected:

  void     Assign           (void*, void const*) const;

  void*    CreateNode       (void const*) const;

  long     CompareKeys      (void const*, void const*,
                             IArgType) const;

  void     DeleteNode       (void*) const;

private:

  enum { kOriginalVersion };

  static
  char const*
           cvClassName;

  MngCursor*
           ivMngCursors;

  Node*    ivRoot;

  INumber  ivNumberOfElements;

  void     AddAllFromSubtree
                            (Node const*);

  IBool AllElementsDoSubtree
                            (IApplFunc, void*, Node*) const;

  void     Balance          (Node*, Direction, IBool&);

  IBool CheckNode        (Node const*, Node*) const;

  IBool ContainsAllKeysFromSubtree
                            (Node const*) const;

  Node*    CopySubtree      (Node const*) const;

  void     DeleteSubtree    (Node*) const;

  void     DisconnectAndRemove
                            (Node*, IBool&);

  void*    ElementOf        (Node const*) const;

  IBool IsConsistentSubtree
                            (Node const*, int&, INumber&) const;

  static
  IBool IsInBetween      (ICursorImpl const&);

  static
  Node*&   NextNodeOf       (ICursorImpl const&);

  static
  Node*&   NodeOf           (ICursorImpl const&);

  static
  Ops&     OpsOf            (IKeySortedSetAsAvlTreeImpl const&);

  static
  Node*&   PreviousNodeOf   (ICursorImpl const&);

  void     ReplaceNode      (Node*, Node*);

  void     SetInBetween     (MngCursor&) const;

  friend
  class    IKeySortedSetAsAvlTreeMngCursorImpl;

  friend
  class    IKeySetOnKeySortedSetImpl <Self>;

  friend
  class    ISortedBagOnKeySortedSetImpl <Self>;

  friend
  class    ISortedMapOnKeySortedSetImpl <Self>;

#if ! defined (__INO_STREAMING__)
protected:
  void     AddFromStream
                            (IDataStream&, ICursorImpl&);

  void*    CreateNodeWithStreamer
                              (IDataStream&) const;

public:
  IStreamerPtr&
           StreamerOf       (IACollectionImpl const&);

  void     StreamIn         (IDataStream&);

  void     StreamOut        (IDataStream&) const;

  void     AdoptStreamer    (IACollectionStreamer*);
#endif












































};

class IC_EXPORTC IAKeySortedSetAsAvlTreeOps {
public:

  virtual ~IAKeySortedSetAsAvlTreeOps
                            ();

  virtual
  void     Assign           (void*, void const*) const = 0;

  virtual
  IACollectionImpl*
           Clone            () const = 0;

  virtual
  long     CompareKeys      (void const*, void const*,
                             IArgType) const = 0;

  virtual
  void*    CreateNode       (void const*) const = 0;

  virtual
  void     DeleteNode       (void*) const = 0;

  virtual
  void*    Key              (void const*) const = 0;

protected:

           IAKeySortedSetAsAvlTreeOps
                            (IBool);

private:

  IBool ivContainsDTSObjects;

  friend
  class    IKeySortedSetAsAvlTreeImpl;

#if ! defined(__INO_STREAMING__)
public:
  virtual
  void*    CreateNodeWithStreamer
                            (IACollectionStreamer*,
                             IDataStream&) const = 0;
#endif
















};

template <class Element, class _Key,
          class ElementOps, class Implementation>
class IC_EXPORTC IKeySortedSetAsAvlTreeOps : public IAKeySortedSetAsAvlTreeOps {

  typedef  IAKeySortedSetAsAvlTreeOps Inherited;

  typedef  IKeySortedSetAsAvlTreeOps
            <Element, _Key, ElementOps, Implementation> Self;

  typedef  IKeySortedSetAsAvlTreeNodeImpl <Element> Node;

public:

  typedef  Implementation ImplType;

  typedef  Element ElementType;

  typedef  _Key KeyType;

           IKeySortedSetAsAvlTreeOps
                            (INumber);

           IKeySortedSetAsAvlTreeOps
                            (INumber, void*);

           IKeySortedSetAsAvlTreeOps
                            (IKeySortedSetAsAvlTreeOps
                              <Element, _Key,
                               ElementOps, Implementation> const&);

          ~IKeySortedSetAsAvlTreeOps
                            ();

  void     Assign           (void*, void const*) const;

  IACollectionImpl*
           Clone            () const;

  long     CompareKeys      (void const*, void const*, IArgType) const;

  void*    CreateNode       (void const*) const;

  void     DeleteNode       (void*) const;

  void*    Key              (void const*) const;

           operator Implementation*
                            ();



















protected:

private:

  ElementOps
           ivElementOps;

  Implementation
           ivImpl;

#if ! defined (__INO_STREAMING__)
  void*    CreateNodeWithStreamer
                            (IACollectionStreamer*, IDataStream&) const;
#endif












};

#pragma pack (pop)
#pragma enum (pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif









#include <iikssavl.inl>




#if ! defined (__TEMPINC__)
#include <iikssavl.c>
#endif


#endif // _IIKSSAVL_
