// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 46 1.4.1.2 source/core/collect/iikstab.c, collection, ioc.v400, 981126 
#ifndef _IIKSTAB_C_
#define _IIKSTAB_C_





// ---
// IKeySetAsTableOps
// ---

// public members

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsTableOps <Element, Key, ElementOps, Implementation>::
IKeySetAsTableOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsTableOps <Element, Key, ElementOps, Implementation>::
IKeySetAsTableOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsTableOps <Element, Key, ElementOps, Implementation>::
IKeySetAsTableOps
  (IKeySetAsTableOps
    <Element, Key, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsTableOps <Element, Key, ElementOps, Implementation>::
~IKeySetAsTableOps ()
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IACollectionImpl*
IKeySetAsTableOps <Element, Key, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsTableOps <Element, Key, ElementOps, Implementation>::
operator IKeySortedSetAsTableImpl& ()
{ return *(IKeySortedSetAsTableImpl*)ivBase ;
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsTableOps <Element, Key, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}





#endif // _IIKSTAB_C_
