// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 79 1.6.1.5 source/core/collect/iirelhsh.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IIRELHSH_
#define _IIRELHSH_

#include <iirelkb.h>
#include <iikbhsh.h>


















#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

typedef IRelationOnKeyBagImpl
         <IKeyBagAsHshTableImpl> IRelationAsHshTableImpl;

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class _Key,
          class ElementOps, class Implementation>
class IC_EXPORTC IRelationAsHshTableOps :
  public IARelationOnKeyBagOps
          <IKeyBagAsHshTableImpl> {

  typedef  IRelationAsHshTableOps
            <Element, _Key, ElementOps, Implementation> Self;

  typedef  IKeyBagAsHshTableOps
            <Element, _Key,
             ElementOps, IKeyBagAsHshTableImpl> Base;

public:

  typedef  Implementation ImplType;

  typedef  Element ElementType;

  typedef  _Key KeyType;

           IRelationAsHshTableOps
                           (INumber);

           IRelationAsHshTableOps
                           (INumber, void*);

           IRelationAsHshTableOps
                           (IRelationAsHshTableOps
                             <Element, _Key,
                              ElementOps, Implementation> const&);

          ~IRelationAsHshTableOps
                           ();

  IACollectionImpl*
           Clone           () const;

  IBool     EqualElements   (void const*, void const*) const;

           operator IKeyBagAsHshTableImpl&
                           ();

           operator Implementation*
                           ();


















protected:

private:

  ElementOps
           ivElementOps;

  Base     ivBase;

  Implementation
           ivImpl;












};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif








#if ! defined (__TEMPINC__)
#include <iirelhsh.c>
#endif






#endif // _IIRELHSH_
