// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 16 1.4.1.2 source/core/collect/iisetbst.c, collection, ioc.v400, 981126 
#ifndef _IISETBST_C_
#define _IISETBST_C_





// ---
// ISetAsBstTreeOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
ISetAsBstTreeOps <Element, ElementOps, Implementation>::
ISetAsBstTreeOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISetAsBstTreeOps <Element, ElementOps, Implementation>::
ISetAsBstTreeOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISetAsBstTreeOps <Element, ElementOps, Implementation>::
ISetAsBstTreeOps
  (ISetAsBstTreeOps
    <Element, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
ISetAsBstTreeOps <Element, ElementOps, Implementation>::
~ISetAsBstTreeOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
ISetAsBstTreeOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
ISetAsBstTreeOps <Element, ElementOps, Implementation>::
operator IKeySetAsBstTreeImpl& ()
{ return *(IKeySetAsBstTreeImpl*)ivBase ;
}

template <class Element, class ElementOps, class Implementation>
ISetAsBstTreeOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}





#endif // _IISETBST_C_
