// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 58 1.5.1.3 source/core/collect/iisrlst.c, collection, ioc.v400, trackPseudoLevel 
#ifndef _IISRLST_C_
#define _IISRLST_C_





// ---
// ISortedRelationAsListOps
// ---

// public members

template <class Element, class Key,
          class ElementOps, class Implementation>
ISortedRelationAsListOps
 <Element, Key, ElementOps, Implementation>::
ISortedRelationAsListOps (INumber numberOfElements)
: ivElementOps (),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
ISortedRelationAsListOps
  <Element, Key, ElementOps, Implementation>::
ISortedRelationAsListOps (INumber numberOfElements, void* opsArg)
: ivElementOps (opsArg),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
ISortedRelationAsListOps
 <Element, Key, ElementOps, Implementation>::
ISortedRelationAsListOps
  (ISortedRelationAsListOps
    <Element, Key, ElementOps, Implementation> const& collection)
: ivElementOps (collection.ivElementOps),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
ISortedRelationAsListOps
 <Element, Key, ElementOps, Implementation>::
~ISortedRelationAsListOps ()
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IACollectionImpl*
ISortedRelationAsListOps
 <Element, Key, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IBool
ISortedRelationAsListOps
 <Element, Key, ElementOps, Implementation>::
EqualElements (void const* element1, void const* element2) const
{ return ivElementOps.Equal (*(Element const*)element1,
                             *(Element const*)element2);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
ISortedRelationAsListOps
 <Element, Key, ElementOps, Implementation>::
operator IKeySortedBagAsListImpl& ()
{ return *(IKeySortedBagAsListImpl*) ivBase;
}

template <class Element, class Key,
          class ElementOps, class Implementation>
ISortedRelationAsListOps
 <Element, Key, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}





#endif // _IISRLST_C_
