// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 67 1.4.1.2 source/core/collect/iissbst.c, collection, ioc.v400, 981126 
#ifndef _IISSBST_C_
#define _IISSBST_C_





// ---
// ISortedSetAsBstTreeOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
ISortedSetAsBstTreeOps <Element, ElementOps, Implementation>::
ISortedSetAsBstTreeOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsBstTreeOps <Element, ElementOps, Implementation>::
ISortedSetAsBstTreeOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsBstTreeOps <Element, ElementOps, Implementation>::
ISortedSetAsBstTreeOps
  (ISortedSetAsBstTreeOps
    <Element, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsBstTreeOps <Element, ElementOps, Implementation>::
~ISortedSetAsBstTreeOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
ISortedSetAsBstTreeOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsBstTreeOps <Element, ElementOps, Implementation>::
operator IKeySortedSetAsBstTreeImpl& ()
{ return *(IKeySortedSetAsBstTreeImpl*)ivBase ;
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsBstTreeOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}





#endif // _IISSBST_C_
