// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 70 1.4.1.2 source/core/collect/iissdil.c, collection, ioc.v400, 981126 
#ifndef _IISSDIL_C_
#define _IISSDIL_C_





// ---
// ISortedSetAsDilTableOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
ISortedSetAsDilTableOps <Element, ElementOps, Implementation>::
ISortedSetAsDilTableOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsDilTableOps <Element, ElementOps, Implementation>::
ISortedSetAsDilTableOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsDilTableOps <Element, ElementOps, Implementation>::
ISortedSetAsDilTableOps
  (ISortedSetAsDilTableOps
    <Element, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsDilTableOps <Element, ElementOps, Implementation>::
~ISortedSetAsDilTableOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
ISortedSetAsDilTableOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsDilTableOps <Element, ElementOps, Implementation>::
operator IKeySortedSetAsDilTableImpl& ()
{ return *(IKeySortedSetAsDilTableImpl*)ivBase ;
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsDilTableOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}





#endif // _IISSDIL_C_
