// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 76 1.4.1.2 source/core/collect/iisslst.c, collection, ioc.v400, 981126 
#ifndef _IISSLST_C_
#define _IISSLST_C_





// ---
// ISortedSetAsListOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
ISortedSetAsListOps <Element, ElementOps, Implementation>::
ISortedSetAsListOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsListOps <Element, ElementOps, Implementation>::
ISortedSetAsListOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsListOps <Element, ElementOps, Implementation>::
ISortedSetAsListOps
  (ISortedSetAsListOps
    <Element, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsListOps <Element, ElementOps, Implementation>::
~ISortedSetAsListOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
ISortedSetAsListOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsListOps <Element, ElementOps, Implementation>::
operator IKeySortedSetAsListImpl& ()
{ return *(IKeySortedSetAsListImpl*)ivBase ;
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsListOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}





#endif // _IISSLST_C_
