// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 00 1.6.1.5 source/core/collect/iivksb.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IIVKSB_
#define _IIVKSB_

#include <ilanglvl.hpp>
#include <iiaksb.h>













#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class VInherited>
class IVKeySortedBagImpl : public VInherited {
public:

  typedef TYPENAME VInherited::Ops Ops;

           IVKeySortedBagImpl
                            (Ops&, INumber);

           IVKeySortedBagImpl
                            (Ops&, IVKeySortedBagImpl
                                    <VInherited> const&);

  IBool     Add              (void const*, ICursorImpl&);

  void     AddAllFrom       (IACollectionImpl const&);

  IBool     AddOrReplaceElementWithKey
                            (void const*, ICursorImpl&);

  void     Copy             (IACollectionImpl const&);

  IBool     LocateOrAddElementWithKey
                            (void const*, ICursorImpl&);

  INumber  RemoveAll        ();

  INumber  RemoveAll        (IPredFunc, void*);

  INumber  RemoveAllElementsWithKey
                            (void const*);

  void     RemoveAt         (ICursorImpl&);

  IBool     RemoveElementWithKey
                            (void const*);

  void     RemoveAtPosition (IPosition);

  void     RemoveFirst      ();

  void     RemoveLast       ();

  void     ReplaceAt        (ICursorImpl const&, void const*);

  IBool     ReplaceElementWithKey
                            (void const*, ICursorImpl&);

protected:

private:












};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif








#if ! defined (__TEMPINC__)
#include <iivksb.c>
#endif






#endif // _IIVKSB_
