// Revision: 81 1.3.1.4 source/ui/baseapp/ikeyhdr.c, userinput, ioc.v400, trackPseudoLevel 
#ifndef _IKEYHDR_C_
#define _IKEYHDR_C_
/*******************************************************************************
* FILE NAME: ikeyhdr.c                                                         *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the template functions                *
*   declared in ikeyhdr.hpp.                                                   * 
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*                                                                              *
*******************************************************************************/
#include <ikeyhdr.hpp>

template<class ATarget>
IKeyboardConnectionTo<ATarget>::IKeyboardConnectionTo ( ATarget&         target,
                                                        KeyboardMemberFn characterKeyMemberFn )
: fTarget( target ), 
  fConnectedCharacterKeyMember( characterKeyMemberFn ),
  fConnectedVirtualKeyMember( 0 )
{ }

template<class ATarget>
IKeyboardConnectionTo<ATarget>::~IKeyboardConnectionTo ( )
{ }

template<class ATarget>
IBool
IKeyboardConnectionTo<ATarget>::characterKeyPress ( IKeyboardEvent& event )
{
  if ( fConnectedCharacterKeyMember )
     return ( fTarget.*fConnectedCharacterKeyMember ) ( event );
  else
     return false;
}

template<class ATarget>
IBool
IKeyboardConnectionTo<ATarget>::virtualKeyPress ( IKeyboardEvent& event )
{
  if ( fConnectedVirtualKeyMember )
     return ( fTarget.*fConnectedVirtualKeyMember ) ( event );
  else
     return false;
}

template<class ATarget>
IKeyboardConnectionTo<ATarget>&
IKeyboardConnectionTo<ATarget>::setVirtualKeyMemberFn ( KeyboardMemberFn virtualKeyMemberFn )
{
  fConnectedVirtualKeyMember = virtualKeyMemberFn;
  return *this;
}
    
#endif // _IKEYHDR_C_
