// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 90 1.4.1.4 source/core/collect/imaplst.inl, collection, ioc.v400, 981126  
#ifndef _IMAPLST_INL_
#define _IMAPLST_INL_

// ---
// IGMapAsListCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGMapAsListCursor <Element, Key, ElementOps>::
IGMapAsListCursor
  (IGMapAsList
    <Element, Key, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGMapAsListCursor <Element, Key, ElementOps>&
IGMapAsListCursor <Element, Key, ElementOps>::
operator=
  (IGMapAsListCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGMapAsListCursor <Element, Key, ElementOps>::
IGMapAsListCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}






























// ---
// IGMapAsList
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGMapAsList <Element, Key, ElementOps>::
IGMapAsList (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new




                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGMapAsList <Element, Key, ElementOps>::
IGMapAsList
  (IGMapAsList
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGMapAsList <Element, Key, ElementOps>&
IGMapAsList <Element, Key, ElementOps>::
operator= (IGMapAsList
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGMapAsList <Element, Key, ElementOps>::
IGMapAsList (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGMapAsList
 <Element, Key, ElementOps>::Implementation&
IGMapAsList <Element, Key, ElementOps>::
ImplOf (IGMapAsList
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IMapAsList
// ---

// public members

template <class Element, class Key>
inline
IMapAsList <Element, Key>::
IMapAsList (INumber numberOfElements)
: IGMapAsList
   <Element, Key, IEKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IMapAsList <Element, Key>::
IMapAsList (PureImplementation& impl)
: IGMapAsList
   <Element, Key, IEKCOps <Element, Key> > (impl)
{
}


// ---
// IVGMapAsList
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGMapAsList <Element, Key, ElementOps>::
IVGMapAsList (INumber numberOfElements)
: IGMapAsList
    <Element, Key, ElementOps> (*(Implementation*) *new




                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGMapAsList <Element, Key, ElementOps>::
IVGMapAsList (PureImplementation& impl)
: IGMapAsList
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVMapAsList
// ---

// public members

template <class Element, class Key>
inline
IVMapAsList <Element, Key>::
IVMapAsList (INumber numberOfElements)
: IVGMapAsList
   <Element, Key, IEKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVMapAsList <Element, Key>::
IVMapAsList (PureImplementation& impl)
: IVGMapAsList
   <Element, Key, IEKCOps <Element, Key> > (impl)
{
}


#endif // _IMAPLST_INL_
