/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 12 1.5.1.4 source/albert/graph2d/imatrix.inl, 2d, ioc.v400, 981126 
/*==========================================
||
||  File:  TransformsImp.h (imatrix.inl)
||
||  What:   Albert 2D Transforms inline definitions
||
*/

#ifndef _IMATRIX_INL_
#define _IMATRIX_INL_

inline unsigned long IGrafMatrix::timeStamp() const
{
    return (fTimeStamp);
}

//=============================//
// Inline IGrafMatrix routines //
//=============================//
// operator*= is inline because it is a pseudonym for concatWith

inline IGrafMatrix& IGrafMatrix::operator*=(const IGrafMatrix& matrix)
{
    concatWith(matrix);
    return (*this);
}

#endif // _IMATRIX_INL_
