#ifndef _IQUEUE2_C_
#define _IQUEUE2_C_
/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*                                                                              *
*******************************************************************************/
#include <iqueue2.h>

template <class Element, class Imp>
  ITImpQueue< Element, Imp>::ITImpQueue(unsigned long numberOfElements )
      : fNumberOfElements(numberOfElements)
{}

template <class Element, class Imp>
  ITImpQueue< Element, Imp>::~ITImpQueue( )
{}

template <class Element>
  IQueue< Element>::IQueue(unsigned long numberOfElements )
       : ITImpQueue<Element, Element>(numberOfElements)
{}

template <class Element>
  IQueue< Element>::~IQueue( )
{}

#ifdef IC_USE_STL_VPTR
  template <class Element>
    IVPtrQueue< Element>::IVPtrQueue(unsigned long numberOfElements )
         : ITImpQueue<Element, void*>(numberOfElements)
  {}

  template <class Element>
    IVPtrQueue< Element>::~IVPtrQueue( )
  {}
#endif

#endif // _IQUEUE2_C_
