// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 98 1.4.1.4 source/core/collect/iseqdil.inl, collection, ioc.v400, 981126  
#ifndef _ISEQDIL_INL_
#define _ISEQDIL_INL_

// ---
// IGSequenceAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGSequenceAsDilTableCursor <Element, ElementOps>::
IGSequenceAsDilTableCursor
  (IGSequenceAsDilTable
    <Element, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGSequenceAsDilTableCursor <Element, ElementOps>&
IGSequenceAsDilTableCursor <Element, ElementOps>::
operator=
  (IGSequenceAsDilTableCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSequenceAsDilTableCursor <Element, ElementOps>::
IGSequenceAsDilTableCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}






























// ---
// IGSequenceAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IGSequenceAsDilTable <Element, ElementOps>::
IGSequenceAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new




                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGSequenceAsDilTable <Element, ElementOps>::
IGSequenceAsDilTable
  (IGSequenceAsDilTable
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGSequenceAsDilTable <Element, ElementOps>&
IGSequenceAsDilTable <Element, ElementOps>::
operator= (IGSequenceAsDilTable
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSequenceAsDilTable <Element, ElementOps>::
IGSequenceAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGSequenceAsDilTable
 <Element, ElementOps>::Implementation&
IGSequenceAsDilTable <Element, ElementOps>::
ImplOf (IGSequenceAsDilTable
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// ISequenceAsDilTable
// ---

// public members

template <class Element>
inline
ISequenceAsDilTable <Element>::
ISequenceAsDilTable (INumber numberOfElements)
: IGSequenceAsDilTable
   <Element, IStdOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
ISequenceAsDilTable <Element>::
ISequenceAsDilTable (PureImplementation& impl)
: IGSequenceAsDilTable
   <Element, IStdOps <Element> > (impl)
{
}


// ---
// IVGSequenceAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IVGSequenceAsDilTable <Element, ElementOps>::
IVGSequenceAsDilTable (INumber numberOfElements)
: IGSequenceAsDilTable
    <Element, ElementOps> (*(Implementation*) *new




                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGSequenceAsDilTable <Element, ElementOps>::
IVGSequenceAsDilTable (PureImplementation& impl)
: IGSequenceAsDilTable
    <Element, ElementOps> (impl)
{
}

// ---
// IVSequenceAsDilTable
// ---

// public members

template <class Element>
inline
IVSequenceAsDilTable <Element>::
IVSequenceAsDilTable (INumber numberOfElements)
: IVGSequenceAsDilTable
   <Element, IStdOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVSequenceAsDilTable <Element>::
IVSequenceAsDilTable (PureImplementation& impl)
: IVGSequenceAsDilTable
   <Element, IStdOps <Element> > (impl)
{
}


#endif // _ISEQDIL_INL_
