// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 13 1.4.1.4 source/core/collect/isethsh.inl, collection, ioc.v400, 981126  
#ifndef _ISETHSH_INL_
#define _ISETHSH_INL_

// ---
// IGSetAsHshTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGSetAsHshTableCursor <Element, ElementOps>::
IGSetAsHshTableCursor
  (IGSetAsHshTable
    <Element, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGSetAsHshTableCursor <Element, ElementOps>&
IGSetAsHshTableCursor <Element, ElementOps>::
operator=
  (IGSetAsHshTableCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSetAsHshTableCursor <Element, ElementOps>::
IGSetAsHshTableCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}






























// ---
// IGSetAsHshTable
// ---

// public members

template <class Element, class ElementOps>
inline
IGSetAsHshTable <Element, ElementOps>::
IGSetAsHshTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new




                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGSetAsHshTable <Element, ElementOps>::
IGSetAsHshTable
  (IGSetAsHshTable
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGSetAsHshTable <Element, ElementOps>&
IGSetAsHshTable <Element, ElementOps>::
operator= (IGSetAsHshTable
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSetAsHshTable <Element, ElementOps>::
IGSetAsHshTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGSetAsHshTable
 <Element, ElementOps>::Implementation&
IGSetAsHshTable <Element, ElementOps>::
ImplOf (IGSetAsHshTable
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// ISetAsHshTable
// ---

// public members

template <class Element>
inline
ISetAsHshTable <Element>::
ISetAsHshTable (INumber numberOfElements)
: IGSetAsHshTable
   <Element, IEHOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
ISetAsHshTable <Element>::
ISetAsHshTable (PureImplementation& impl)
: IGSetAsHshTable
   <Element, IEHOps <Element> > (impl)
{
}


// ---
// IVGSetAsHshTable
// ---

// public members

template <class Element, class ElementOps>
inline
IVGSetAsHshTable <Element, ElementOps>::
IVGSetAsHshTable (INumber numberOfElements)
: IGSetAsHshTable
    <Element, ElementOps> (*(Implementation*) *new




                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGSetAsHshTable <Element, ElementOps>::
IVGSetAsHshTable (PureImplementation& impl)
: IGSetAsHshTable
    <Element, ElementOps> (impl)
{
}

// ---
// IVSetAsHshTable
// ---

// public members

template <class Element>
inline
IVSetAsHshTable <Element>::
IVSetAsHshTable (INumber numberOfElements)
: IVGSetAsHshTable
   <Element, IEHOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVSetAsHshTable <Element>::
IVSetAsHshTable (PureImplementation& impl)
: IVGSetAsHshTable
   <Element, IEHOps <Element> > (impl)
{
}


#endif // _ISETHSH_INL_
