// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 15 1.4.1.4 source/core/collect/isetlst.inl, collection, ioc.v400, 981126  
#ifndef _ISETLST_INL_
#define _ISETLST_INL_

// ---
// IGSetAsListCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGSetAsListCursor <Element, ElementOps>::
IGSetAsListCursor
  (IGSetAsList
    <Element, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGSetAsListCursor <Element, ElementOps>&
IGSetAsListCursor <Element, ElementOps>::
operator=
  (IGSetAsListCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSetAsListCursor <Element, ElementOps>::
IGSetAsListCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}






























// ---
// IGSetAsList
// ---

// public members

template <class Element, class ElementOps>
inline
IGSetAsList <Element, ElementOps>::
IGSetAsList (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new




                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGSetAsList <Element, ElementOps>::
IGSetAsList
  (IGSetAsList
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGSetAsList <Element, ElementOps>&
IGSetAsList <Element, ElementOps>::
operator= (IGSetAsList
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSetAsList <Element, ElementOps>::
IGSetAsList (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGSetAsList
 <Element, ElementOps>::Implementation&
IGSetAsList <Element, ElementOps>::
ImplOf (IGSetAsList
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// ISetAsList
// ---

// public members

template <class Element>
inline
ISetAsList <Element>::
ISetAsList (INumber numberOfElements)
: IGSetAsList
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
ISetAsList <Element>::
ISetAsList (PureImplementation& impl)
: IGSetAsList
   <Element, ICOps <Element> > (impl)
{
}


// ---
// IVGSetAsList
// ---

// public members

template <class Element, class ElementOps>
inline
IVGSetAsList <Element, ElementOps>::
IVGSetAsList (INumber numberOfElements)
: IGSetAsList
    <Element, ElementOps> (*(Implementation*) *new




                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGSetAsList <Element, ElementOps>::
IVGSetAsList (PureImplementation& impl)
: IGSetAsList
    <Element, ElementOps> (impl)
{
}

// ---
// IVSetAsList
// ---

// public members

template <class Element>
inline
IVSetAsList <Element>::
IVSetAsList (INumber numberOfElements)
: IVGSetAsList
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVSetAsList <Element>::
IVSetAsList (PureImplementation& impl)
: IVGSetAsList
   <Element, ICOps <Element> > (impl)
{
}


#endif // _ISETLST_INL_
