// Revision: 83 1.3.1.7 source/ui/basectl/istrgen.c, listctls, ioc.v400, 981126 
#ifndef _ISTRGEN_C_
#define _ISTRGEN_C_
/*******************************************************************************
* FILE NAME: istrgen.cpp                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in istrgen.hpp.                                                            *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   Licensed Material - Property of IBM                                        *
*   (C) Copyright IBM Corp. 1992, 1997  All Rights Reserved.                   *
*                                                                              *
*******************************************************************************/
#include <istrgen.hpp>


// implement empty copy constructor to work-around compiler RTTI bug
template <class T>
  IStringGeneratorFn<T> ::
    IStringGeneratorFn ( const IStringGeneratorFn<T>& generatorFunction  )
{
}

template <class T>
  IStringGeneratorMemberFn<T> ::
    IStringGeneratorMemberFn ( IString ( T :: *member )( ) )
    : memberFunction( member )
{
}

// implement empty copy constructor to work-around compiler RTTI bug
template <class T>
  IStringGeneratorMemberFn<T> ::
    IStringGeneratorMemberFn ( const IStringGeneratorMemberFn<T>& generatorMemberFunction  )
{
}

template <class T>
  IStringGeneratorMemberFn<T> ::
   ~IStringGeneratorMemberFn ( )
{
}

template <class T>
  IString  IStringGeneratorMemberFn<T> :: stringFor ( const T& object ) const
{
  T *  pobject = (T *)&object;
  return (pobject->*memberFunction)( );
}

template <class T>
  IStringGeneratorasString<T> ::
    IStringGeneratorasString ( )

{
}

// implement empty copy constructor to work-around compiler RTTI bug
template <class T>
  IStringGeneratorasString<T> ::
    IStringGeneratorasString ( const IStringGeneratorasString<T>& generatorMemberFunction  )
{
}

template <class T>
  IStringGeneratorasString<T> ::
   ~IStringGeneratorasString ( )
{
}

template <class T>
  IString  IStringGeneratorasString<T> :: stringFor ( const T& object ) const
{
  return object->asString( );
}

template <class T, class U>
  IStringGeneratorRefMemberFn<T,U> ::
    IStringGeneratorRefMemberFn ( IString ( U :: *member )( ) )
    : memberFunction( member )
{
}

// implement empty copy constructor to work-around compiler RTTI bug
template <class T, class U>
  IStringGeneratorRefMemberFn<T,U> ::
    IStringGeneratorRefMemberFn ( const IStringGeneratorRefMemberFn<T,U>& generatorRefMemberFunction  )
{
}

template <class T, class U>
  IStringGeneratorRefMemberFn<T,U> ::
   ~IStringGeneratorRefMemberFn ( )
{
}

template <class T, class U>
  IString  IStringGeneratorRefMemberFn<T,U> :: stringFor ( const T& object ) const
{
  return  (object->*memberFunction)( );
}


template <class Element>
  IStringGenerator<Element> ::
    IStringGenerator( const ICountedPointerTo < IStringGeneratorFn<Element> >&
                         generatorFunction )
    : fgeneratorFunction( generatorFunction )
{
  if ( fgeneratorFunction.getAlias() )
    fgeneratorFunction->addRef( );
}


template <class Element>
  IStringGenerator<Element> ::
    IStringGenerator( const IStringGenerator<Element>&
                         stringGenerator )
    : fgeneratorFunction( stringGenerator.fgeneratorFunction )
{
}


template <class Element>
  IStringGenerator<Element>&
    IStringGenerator<Element> ::
      operator=( const IStringGenerator<Element>&
                    stringGenerator )
{
  fgeneratorFunction = stringGenerator.fgeneratorFunction;
  return *this;
}


template <class Element>
  IStringGenerator<Element> :: ~IStringGenerator ( )
{
}


template <class Element>
  IString IStringGenerator<Element> ::
    stringFor ( const Element& element ) const
{

  return fgeneratorFunction.getAlias()
            ? fgeneratorFunction->stringFor( element )
            : IString()
            ;
}

#endif // _ISTRGEN_C_
