/* Revision: 26 1.3.2.4 source/ui/widgets/notebk.h, cuawidgets, ioc.v400, 981126  */
/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1997, 1997                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
/*
 * (c) Copyright 1989, 1990, 1991, 1992, 1993 OPEN SOFTWARE FOUNDATION, INC.
 * ALL RIGHTS RESERVED
 */
/*
 * Motif top of 2.0 tree as of Tue Jun  1 05:18:29 EDT 1993
 */
#ifndef _NOTEBK_
#define _NOTEBK_

#include <Xm/Xm.h>


#ifdef __cplusplus
extern "C" {
#endif


externalref WidgetClass xmNotebookWidgetClass;

typedef struct _XmNotebookClassRec *XmNotebookWidgetClass;
typedef struct _XmNotebookWidgetRec *XmNotebookWidget;






/************************************************************************
 *  Notebook RepTypes
 ************************************************************************/


/* binding types */
enum
{
/*  XmNONE, */
/*  XmPIXMAP, */
    XmSOLID = 2,
    XmSPIRAL,
    XmPIXMAP_OVERLAP_ONLY
};


/* child types */
enum
{   /* XmNONE */
    XmPAGE = 1,
    XmMAJOR_TAB,
    XmMINOR_TAB,
    XmSTATUS_AREA,
    XmPAGE_SCROLLER
};





/************************************************************************
 *  Notebook Defines
 ************************************************************************/

/* XmNotebookPageStatus */
typedef enum
{
    XmPAGE_FOUND,               /* page widget found */
    XmPAGE_INVALID,             /* page number out of the range */
    XmPAGE_EMPTY,               /* no page widget found */
    XmPAGE_DUPLICATED           /* there are more than 1 page widgets */
} XmNotebookPageStatus;

/* Notebook page information structure */
typedef struct
{
    int         page_number;
    Widget      page_widget;
    Widget      status_area_widget;
    Widget      major_tab_widget;
    Widget      minor_tab_widget;
} XmNotebookPageInfo;


/* ScrollFrame Traits Notebook dimensions */
#define NavigDimensionPageNumber        (1L)

/* Notebook Magic Values */
#define XmUNSPECIFIED_PAGE_NUMBER       (-32768)

/* names of notebook internal children */
#define XmPAGE_SCROLLER_NAME            "PageScroller"
#define XmMAJOR_TAB_NEXT_NAME           "MajorTabScrollerNext"
#define XmMAJOR_TAB_PREV_NAME           "MajorTabScrollerPrev"
#define XmMINOR_TAB_NEXT_NAME           "MinorTabScrollerNext"
#define XmMINOR_TAB_PREV_NAME           "MinorTabScrollerPrev"




/************************************************************************
 *  Resource names
 ************************************************************************/

/* resource names */
#define XmNcurrentPageNumber            "currentPageNumber"
#define XmNfirstPageNumber              "firstPageNumber"
#define XmNlastPageNumber               "lastPageNumber"
#define XmNbackPagePlacement            "backPagePlacement"
#define XmNbackPageNumber               "backPageNumber"
#define XmNbackPageSize                 "backPageSize"
#define XmNbackPageForeground           "backPageForeground"
#define XmNbackPageBackground           "backPageBackground"
#define XmNframeBackground              "frameBackground"
#define XmNbindingType                  "bindingType"
#define XmNbindingPixmap                "bindingPixmap"
#define XmNbindingWidth                 "bindingWidth"
#define XmNmajorTabSpacing              "majorTabSpacing"
#define XmNminorTabSpacing              "minorTabSpacing"
#define XmNinnerMarginWidth             "innerMarginWidth"
#define XmNinnerMarginHeight            "innerMarginHeight"
#define XmNframeShadowThickness         "frameShadowThickness"
#define XmNpageChangedCallback          "pageChangedCallback"
#define XmNpageNumber                   "pageNumber"
#define XmNnotebookChildType            "notebookChildType"

/* resource class names */
#define XmCCurrentPageNumber            "CurrentPageNumber"
#define XmCFirstPageNumber              "FirstPageNumber"
#define XmCLastPageNumber               "LastPageNumber"
#define XmCBackPagePlacement            "BackPagePlacement"
#define XmCBackPageNumber               "BackPageNumber"
#define XmCBackPageSize                 "BackPageSize"
#define XmCBackPageForeground           "BackPageForeground"
#define XmCBackPageBackground           "BackPageBackground"
#define XmCFrameBackground              "FrameBackground"
#define XmCBindingType                  "BindingType"
#define XmCBindingPixmap                "BindingPixmap"
#define XmCBindingWidth                 "BindingWidth"
#define XmCMajorTabSpacing              "MajorTabSpacing"
#define XmCMinorTabSpacing              "MinorTabSpacing"
#define XmCInnerMarginWidth             "InnerMarginWidth"
#define XmCInnerMarginHeight            "InnerMarginHeight"
#define XmCFrameShadowThickness         "FrameShadowThickness"
#define XmCPageChangeCallback           "PageChangeCallback"
#define XmCPageNumber                   "PageNumber"
#define XmCNotebookChildType            "NotebookChildType"

#define XmRBindingType                  "BindingType"
#define XmRNotebookChildType            "NotebookChildType"




/****************************************************************************
 *  Callback reasons
 ****************************************************************************/

enum
{
    XmCR_PAGE_SCROLLER_INCREMENT = 100,
    XmCR_PAGE_SCROLLER_DECREMENT,
    XmCR_MAJOR_TAB,
    XmCR_MINOR_TAB
};





/************************************************************************
 *  Callback structures
 ************************************************************************/

typedef struct
{
    int         reason;
    XEvent      *event;
    int         page_number;
    Widget      page_widget;
    int         prev_page_number;
    Widget      prev_page_widget;
} XmNotebookCallbackStruct;










/************************************************************************
 *  Public Functions
 ************************************************************************/

#ifndef XmIsNotebook
#define XmIsNotebook(w) XtIsSubclass((Widget)w, xmNotebookWidgetClass)
#endif

#ifdef _NO_PROTO
extern  Widget  XmCreateNotebook();
extern XmNotebookPageStatus XmNotebookGetPageInfo();
extern XuicMinSize();
extern XuicPageSize();

#else
extern  Widget  XmCreateNotebook(
                        Widget          parent,
                        char *          name,
                        ArgList         arglist,
                        Cardinal        argcount);
extern XmNotebookPageStatus XmNotebookGetPageInfo(Widget notebook,
        int page_number, XmNotebookPageInfo *page_info);

extern void XuiclMinSize(Widget    notebook, 
                         Dimension pageWidth,
                         Dimension pageHeight,
                         Dimension *width,
                         Dimension *height);
extern void XuiclPageSize(Widget notebook, 
                         Dimension *width,
                         Dimension *height);

#endif





#ifdef __cplusplus
}
#endif

#endif // _NOTEBK_

